diff --git a/drivers/mmc/host/sdhci.c b/drivers/mmc/host/sdhci.c
index 9c37451..8f4b985 100644
--- a/drivers/mmc/host/sdhci.c
+++ b/drivers/mmc/host/sdhci.c
@@ -1538,14 +1538,15 @@ static void sdhci_finish_data(struct sdhci_host *host)
 		} else {
 			/* Avoid triggering warning in sdhci_send_command() */
 			host->cmd = NULL;
-			sdhci_send_command(host, data->stop);
+			sdhci_send_command(host, data->stop, true);
 		}
 	} else {
 		__sdhci_finish_mrq(host, data->mrq);
 	}
 }
 
-void sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd)
+int sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd,
+		       bool polling)
 {
 	int flags;
 	u32 mask;
@@ -1573,13 +1574,26 @@ void sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd)
 		mask &= ~SDHCI_DATA_INHIBIT;
 
 	while (sdhci_readl(host, SDHCI_PRESENT_STATE) & mask) {
-		if (timeout == 0) {
+		if (!polling) {
+			pr_err("%s: Controller has not released inhibit bit(s), try again.\n",
+			       mmc_hostname(host->mmc));
+
+			/*
+			 * HSQ may send a command in interrupt context without
+			 * polling the busy signaling, which means we should
+			 * return BUSY if controller has not released inhibit
+			 * bits to allow HSQ trying to send request again in
+			 * non-atomic context. so we should not finish this
+			 * request here.
+			 */
+			return -EBUSY;
+		} else if (timeout == 0) {
 			pr_err("%s: Controller never released inhibit bit(s).\n",
 			       mmc_hostname(host->mmc));
 			sdhci_dumpregs(host);
 			cmd->error = -EIO;
 			sdhci_finish_mrq(host, cmd->mrq);
-			return;
+			return -EIO;
 		}
 		timeout--;
 		mdelay(1);
@@ -1609,7 +1623,7 @@ void sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd)
 			mmc_hostname(host->mmc));
 		cmd->error = -EINVAL;
 		sdhci_finish_mrq(host, cmd->mrq);
-		return;
+		return -EINVAL;
 	}
 
 	if (!(cmd->flags & MMC_RSP_PRESENT))
@@ -1644,6 +1658,8 @@ void sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd)
 		sdhci_external_dma_pre_transfer(host, cmd);
 
 	sdhci_writew(host, SDHCI_MAKE_CMD(cmd->opcode, flags), SDHCI_COMMAND);
+
+	return 0;
 }
 EXPORT_SYMBOL_GPL(sdhci_send_command);
 
@@ -1706,7 +1722,7 @@ static void sdhci_finish_command(struct sdhci_host *host)
 
 	/* Finished CMD23, now send actual command. */
 	if (cmd == cmd->mrq->sbc) {
-		sdhci_send_command(host, cmd->mrq->cmd);
+		sdhci_send_command(host, cmd->mrq->cmd, true);
 	} else {
 
 		/* Processed actual command. */
@@ -2016,16 +2032,12 @@ void sdhci_set_power(struct sdhci_host *host, unsigned char mode,
  *                                                                           *
 \*****************************************************************************/
 
-void sdhci_request(struct mmc_host *mmc, struct mmc_request *mrq)
+static int sdhci_start_request(struct mmc_host *mmc, struct mmc_request *mrq,
+				int present, bool polling)
 {
-	struct sdhci_host *host;
-	int present;
+	struct sdhci_host *host = mmc_priv(mmc);
 	unsigned long flags;
-
-	host = mmc_priv(mmc);
-
-	/* Firstly check card presence */
-	present = mmc->ops->get_cd(mmc);
+	int ret;
 
 	spin_lock_irqsave(&host->lock, flags);
 
@@ -2033,15 +2045,34 @@ void sdhci_request(struct mmc_host *mmc, struct mmc_request *mrq)
 
 	if (!present || host->flags & SDHCI_DEVICE_DEAD) {
 		mrq->cmd->error = -ENOMEDIUM;
+		ret = -ENOMEDIUM;
 		sdhci_finish_mrq(host, mrq);
 	} else {
 		if (mrq->sbc && !(host->flags & SDHCI_AUTO_CMD23))
-			sdhci_send_command(host, mrq->sbc);
+			ret = sdhci_send_command(host, mrq->sbc, polling);
 		else
-			sdhci_send_command(host, mrq->cmd);
+			ret = sdhci_send_command(host, mrq->cmd, polling);
 	}
 
 	spin_unlock_irqrestore(&host->lock, flags);
+
+	return ret;
+}
+
+int sdhci_request_atomic(struct mmc_host *mmc, struct mmc_request *mrq)
+{
+	return sdhci_start_request(mmc, mrq, 1, false);
+}
+EXPORT_SYMBOL_GPL(sdhci_request_atomic);
+
+void sdhci_request(struct mmc_host *mmc, struct mmc_request *mrq)
+{
+	int present;
+
+	/* Firstly check card presence */
+	present = mmc->ops->get_cd(mmc);
+
+	sdhci_start_request(mmc, mrq, present, true);
 }
 EXPORT_SYMBOL_GPL(sdhci_request);
 
@@ -2581,7 +2612,7 @@ void sdhci_send_tuning(struct sdhci_host *host, u32 opcode)
 	 */
 	sdhci_writew(host, SDHCI_TRNS_READ, SDHCI_TRANSFER_MODE);
 
-	sdhci_send_command(host, &cmd);
+	sdhci_send_command(host, &cmd, true);
 
 	host->cmd = NULL;
 
diff --git a/drivers/mmc/host/sdhci.h b/drivers/mmc/host/sdhci.h
index cac2d97..73e15c5 100644
--- a/drivers/mmc/host/sdhci.h
+++ b/drivers/mmc/host/sdhci.h
@@ -759,7 +759,8 @@ void __sdhci_read_caps(struct sdhci_host *host, const u16 *ver,
 int __sdhci_add_host(struct sdhci_host *host);
 int sdhci_add_host(struct sdhci_host *host);
 void sdhci_remove_host(struct sdhci_host *host, int dead);
-void sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd);
+int sdhci_send_command(struct sdhci_host *host, struct mmc_command *cmd,
+		       bool polling);
 
 static inline void sdhci_read_caps(struct sdhci_host *host)
 {
@@ -775,6 +776,7 @@ void sdhci_set_power(struct sdhci_host *host, unsigned char mode,
 void sdhci_set_power_noreg(struct sdhci_host *host, unsigned char mode,
 			   unsigned short vdd);
 void sdhci_request(struct mmc_host *mmc, struct mmc_request *mrq);
+int sdhci_request_atomic(struct mmc_host *mmc, struct mmc_request *mrq);
 void sdhci_set_bus_width(struct sdhci_host *host, int width);
 void sdhci_reset(struct sdhci_host *host, u8 mask);
 void sdhci_set_uhs_signaling(struct sdhci_host *host, unsigned timing);